//______________________________________________________________________________________________________________________
bUseResult = true;
bSendResult = false;

//______________________________________________________________________________________________________________________
function LoadStartPage(szTemplateFileName)
{
	window.open(szTemplateFileName, "ModemHelper", "width = 800, height = 600"+
				", toolbar = no, location = no, status = no, scrollbars = yes" +
				", resizable = no");
}

//______________________________________________________________________________________________________________________
function ModemHelper_Result(iDiagnosticCode)
{
	bSendResult = true;
	if (bUseResult)
	{
		ButtonCollection = document.all.tags("INPUT");

		if (ButtonCollection != null)
		{
			for (i = 0; i < ButtonCollection.length; i++)
			{
				ButtonCollection(i).disabled = true;
			}
		}
		try
		{
			ModemHelper.Result(iDiagnosticCode);
		}
		catch(e)
		{
			external.Result(iDiagnosticCode);
		}
	}
}

//______________________________________________________________________________________________________________________
function ModemHelper_ShowToolTip(szToolTipName, szToolTipContents)
{
	try
	{
		ModemHelper.ShowToolTip(window.event.screenX, window.event.screenY, szToolTipName, szToolTipContents);
	}
	catch(e)
	{
		external.ShowToolTip(szToolTipName, szToolTipContents);
	}
}

//______________________________________________________________________________________________________________________
function ModemHelper_InputVar(szVariableName, szVariableValue)
{
	try
	{
		ModemHelper.InputVar(szVariableName, szVariableValue);
	}
	catch(e)
	{
		external.InputVar(szVariableName, szVariableValue);
	}
}

//______________________________________________________________________________________________________________________
function ModemHelper_InputResult(iInputNumber, szResult)
{
	try
	{
		ModemHelper.InputResult(iInputNumber, szResult);
	}
	catch(e)
	{
		external.InputResult(iInputNumber, szResult);
	}
}

//______________________________________________________________________________________________________________________
function PrintPage()
{
	window.print();
}

//______________________________________________________________________________________________________________________
function SetVariable(szVariableName, szVariableValue, iDiagnosticCode)
{
	ModemHelper_InputVar(szVariableName, szVariableValue);
	ModemHelper_Result(iDiagnosticCode);
}

//______________________________________________________________________________________________________________________
function VariableValueHaveSpaces(szVariableValue)
{
	for (i = 0; i < szVariableValue.length; i++)
	{
		if (szVariableValue.charAt(i) == ' ')
			return true;
	}
	return false;
}

//______________________________________________________________________________________________
function SetInputVar(InputVariable, iDiagnosticCode, szErrorMessage, iMinimumValue, iMaximumValue,
					 iNoSpace)
{
	if (InputVariable.value.length < iMinimumValue || InputVariable.value.length > iMaximumValue ||
		(iNoSpace && VariableValueHaveSpaces(InputVariable.value)))
	{
		alert(szErrorMessage);
		InputVariable.focus();
		return false;
	}
	SetVariable(InputVariable.name, InputVariable.value, iDiagnosticCode)
	return true;
}

//______________________________________________________________________________________________
function SetInputVarTable()
{
	cArguments = SetInputVarTable.arguments;
	iNbArguments = cArguments.length - 1;
	iDiagnosticCode = cArguments[iNbArguments];
	while (iNbArguments >= 4)
	{
		if (cArguments[iNbArguments - 4].value.length < cArguments[iNbArguments - 2] ||
			cArguments[iNbArguments - 4].value.length > cArguments[iNbArguments - 1])
		{
			alert(cArguments[iNbArguments - 3]);
			cArguments[iNbArguments - 4].focus();
			return false;
		}
		ModemHelper_InputVar(cArguments[iNbArguments - 4].name, cArguments[iNbArguments - 4].value);
		iNbArguments -= 4;
	}
	ModemHelper_Result(iDiagnosticCode);
	return true;
}

//______________________________________________________________________________________________
function VerifyWepPassphrase(szErrorMessage, iDiagnosticCode)
{
	TheForm = document.Form;
	
	if (TheForm.PassPhrase.value.length < 8)
	{
		alert(szErrorMessage);
		TheForm.PassPhrase.focus();
		return false;
	}
	ModemHelper_InputResult(0, TheForm.PassPhrase.value);
	ModemHelper_Result(iDiagnosticCode);
	return true;
}

//______________________________________________________________________________________________
function VerifySSIDName(szErrorMessage, iDiagnosticCode)
{
	TheForm = document.Form;
	
	if (TheForm.PassPhrase.value.length < 1 ||
		TheForm.PassPhrase.value.length > 32)
	{
		alert(szErrorMessage);
		TheForm.PassPhrase.focus();
		return false;
	}
	ModemHelper_InputResult(0, TheForm.PassPhrase.value);
	ModemHelper_Result(iDiagnosticCode);
	return true;
}

//______________________________________________________________________________________________
function WriteWorkgroupAndComputer()
{
	TheForm = document.Form;

	if (TheForm.workgroup.value == "")
	{
		alert("Work group incorrect");
		TheForm.workgroup.focus();
		return false;
	}
	if (TheForm.computer.value == "")
	{
		alert("Computer name incorrect");
		TheForm.computer.focus();
		return false;
	}
	if (typeof ModemHelper.Computer == "undefined")
		external.Computer = TheForm.computer.value;
	else
		ModemHelper.Computer = TheForm.computer.value;
	if (typeof ModemHelper.Workgroup == "undefined")
		external.Workgroup = TheForm.workgroup.value;
	else
		ModemHelper.Workgroup = TheForm.workgroup.value;
	ModemHelper_Result(1);
	return true;
}

//______________________________________________________________________________________________
function LoadWorkgroupAndComputer()
{
	if (typeof ModemHelper.Workgroup == "undefined")
		document.Form.workgroup.value = external.Workgroup;
	else
		document.Form.workgroup.value = ModemHelper.Workgroup;
	if (typeof ModemHelper.Computer == "undefined")
		document.Form.computer.value = external.Computer;
	else
		document.Form.computer.value = ModemHelper.Computer;
}

//______________________________________________________________________________________________
function ProgressBar_CreateProgressBar(objParentElement, strIdProgressBar)
{
	var objTable, objRow, objCell;
	
	//	CREATE PROGRESS OBJECT
	var objProgressBar = document.createElement("TABLE");
	objProgressBar = objParentElement.applyElement(objProgressBar, "inside");
	objProgressBar.id = "PROGRESSBAR" + strIdProgressBar;
	objProgressBar.cellPadding = "2";
	objProgressBar.cellSpacing = "0";
	objProgressBar.border = "0";
	objProgressBar._MIN_RANGE = 1;
	objProgressBar._MAX_RANGE = 100;
	objProgressBar._STEP = 10;
	objProgressBar._PREVIOUS_POS = 0;
	
	//	CREATE PROGRESS MESSAGE
	objRow = objProgressBar.insertRow(-1);
	objCell = objRow.insertCell(-1);
	objCell.style.textAlign = "left";
	objCell.innerText = " ";
	
	//	CREATE PROGRESS BAR
	objRow = objProgressBar.insertRow(-1);
	objCell = objRow.insertCell(-1);
	objCell.style.width = "200";
	objCell.style.height = "20";
	
	objTable = document.createElement("TABLE");
	objTable = objCell.applyElement(objTable, "inside");
	objTable.cellPadding = "2";
	objTable.cellSpacing = "2";
	objTable.style.border = "1px solid #808080";
	objRow = objTable.insertRow(-1);
	objCell = objRow.insertCell(-1);
	objCell.style.width = "200";
	objCell.style.height = "20";
	objCell.style.backgroundColor = "#A0A0A0";
	
	objTable = document.createElement("TABLE");
	objTable = objCell.applyElement(objTable, "inside");
	objTable.cellPadding = "0";
	objTable.cellSpacing = "0";
	objTable.border = "0";
	objTable.style.height = "100%";
	objRow = objTable.insertRow(-1);
	objCell = objRow.insertCell(-1);
	objCell.style.height = "100%";
	objCell.style.width = "0";
	objCell.backgroundColor = "#000080";
	
	//	CREATE PROGRESS INFORMATION
	objRow = objProgressBar.insertRow(-1);
	objCell = objRow.insertCell(-1);
	objCell.style.textAlign = "center";
	objCell.innerText = "0%";
	
	objProgressBar.style.visibility = "hidden";
	return objProgressBar;
}

//______________________________________________________________________________________________
function ProgressBar_ShowProgressBar(objProgressBar)
{
	objProgressBar.style.visibility = "visible";
	
	return true;
}

//______________________________________________________________________________________________
function ProgressBar_HideProgressBar(objProgressBar)
{
	objProgressBar.style.visibility = "hidden";
	
	return true;
}

//______________________________________________________________________________________________
function ProgressBar_SetRange(objProgressBar, intMinRange, intMaxRange)
{
	objProgressBar.setAttribute("_MIN_RANGE", intMinRange);
	objProgressBar.setAttribute("_MAX_RANGE", intMaxRange);
	objProgressBar.setAttribute("_PREVIOUS_POS", intMinRange);
	
	return true;
}

//______________________________________________________________________________________________
function ProgressBar_GetRange(objProgressBar, blnWhichLimit)
{
	var intRange;
	
	if (blnWhichLimit)
	{
		intRange = objProgressBar.getAttribute("_MIN_RANGE");
	}
	else
	{
		intRange = objProgressBar.getAttribute("_MAX_RANGE");
	}
	
	return intRange;
}

//______________________________________________________________________________________________
function ProgressBar_SetStep(objProgressBar, intStep)
{

	return; // previous step increment
}

//______________________________________________________________________________________________
function ProgressBar_StepIt(objProgressBar, strComment)
{

	return; // previous position
}

//______________________________________________________________________________________________
function ProgressBar_SetPos(objProgressBar, intPos, strComment)
{
	var intMaxRange = parseInt(objProgressBar.getAttribute("_MAX_RANGE"));
	if (intPos > intMaxRange) intPos = intMaxRange;
	
	var intPreviousPos = parseInt(objProgressBar.getAttribute("_PREVIOUS_POS"));
	var intMinRange = parseInt(objProgressBar.getAttribute("_MIN_RANGE"));
	var intRangeFactor = (intMaxRange - intMinRange)/100;
	var intNextPos = (intPos - intMinRange)/intRangeFactor;
	
	var objTDNextRange = objProgressBar.rows(1).cells(0).children(0).rows(0).cells(0).children(0).rows(0).cells(0);
	objTDNextRange.style.width = Math.round(2*intNextPos) + "px";
	
	var objTRProgressInfo = objProgressBar.rows(2).cells(0);
	objTRProgressInfo.innerText = Math.round(intNextPos) + "%";
	
	var objTRProgressComment = objProgressBar.rows(0).cells(0);
	objTRProgressComment.innerText = strComment;
	
	objProgressBar.setAttribute("_PREVIOUS_POS", intPos);
	
	return intPreviousPos;
}

//______________________________________________________________________________________________
function ProgressBar_DeltaPos(objProgressBar, intDeltaPos, strComment)
{

	return; // previous position
}

//______________________________________________________________________________________________
function ProgressBar_GetPos(objProgressBar)
{
	var intPos = parseInt(objProgressBar.getAttribute("_PREVIOUS_POS"));
	
	return intPos;
}

//______________________________________________________________________________________________
function ProgressBar_SetClassName(objProgressBar, strClassName)
{
	objProgressBar.className = strClassName;
	
	return true;
}

//______________________________________________________________________________________________
function ProgressBar_SetBkColor(objProgressBar, strColor)
{
	
	var objTDBackgroundColor = objProgressBar.rows(1).cells(0).children(0).rows(0).cells(0);
	objTDBackgroundColor.style.backgroundColor = strColor;
	
	return true;
}

//______________________________________________________________________________________________
function ProgressBar_SetBorderColor(objProgressBar, strColor)
{
	var objTABLEBorderColor = objProgressBar.rows(1).cells(0).children(0);
	objTABLEBorderColor.style.borderColor = strColor;
	
	return true;
}

//______________________________________________________________________________________________
function ProgressBar_SetBarColor(objProgressBar, strColor)
{
	var objTDBarColor = objProgressBar.rows(1).cells(0).children(0).rows(0).cells(0).children(0).rows(0).cells(0);
	objTDBarColor.style.backgroundColor = strColor;
	
	return true;
}

//______________________________________________________________________________________________
function ProgressBar_RemoveProgressBar(objProgressBar)
{
	if (objProgressBar)
	{
		var objParent = objProgressBar.parentElement;

		objParent.removeChild(objProgressBar);
		objProgressBar = null;
	}
	
	return true;
}

//______________________________________________________________________________________________
function ModemHelper_StartProgressBar(strComment, strIdProgressBar)
{
	var objProgressBar = ProgressBar_CreateProgressBar(document.getElementById(strIdProgressBar), strIdProgressBar);
	ProgressBar_SetBkColor(objProgressBar, "#FF0000");
	ProgressBar_SetBorderColor(objProgressBar, "#00FF00");
	ProgressBar_SetBarColor(objProgressBar, "#0000FF");
	ProgressBar_SetRange(objProgressBar, 0, 100);
	ProgressBar_ShowProgressBar(objProgressBar);
	try
	{
		ModemHelper.StartProgressBar();
	}
	catch(e)
	{
		external.StartProgressBar();
	}
	ModemHelper_ControlProgressBar(strComment, objProgressBar.id);
}

//______________________________________________________________________________________________
function ModemHelper_StopProgressBar()
{
	var bStopProgressBar;

	if (typeof ModemHelper.StopProgressBar == "undefined")
		bStopProgressBar = external.StopProgressBar;
	else
		bStopProgressBar = ModemHelper.StopProgressBar;
	return bStopProgressBar;
}

//______________________________________________________________________________________________
function ModemHelper_PositionProgressBar()
{
	var iPosition;

	if (typeof ModemHelper.PositionProgressBar == "undefined")
		iPosition = external.PositionProgressBar;
	else
		iPosition = ModemHelper.PositionProgressBar;
	return iPosition;
}

//______________________________________________________________________________________________________________________
function ModemHelper_ControlProgressBar(strComment, strIdProgressBar)
{
	var g_objProgressBar = document.getElementById(strIdProgressBar);
	var iPosition;

	if (ModemHelper_StopProgressBar())
		iPosition = 100;
	else
		iPosition = ModemHelper_PositionProgressBar();
	if (iPosition > 100)
		iPosition = 100;
	ProgressBar_SetPos(g_objProgressBar, iPosition, strComment);
	if (!ModemHelper_StopProgressBar())
		setTimeout("ModemHelper_ControlProgressBar('" + strComment + "', \"" + strIdProgressBar + "\")", 1);
}

//______________________________________________________________________________________________________________________
function ModemHelper_DisplayGifProgressBar(strIdProgressBar, strGifFolder)
{
	var objProgressBar = document.getElementById(strIdProgressBar);
	var iPosition;

	if (ModemHelper_StopProgressBar())
		iPosition = 100;
	else
		iPosition = ModemHelper_PositionProgressBar();
	if (iPosition > 100)
		iPosition = 100;
	objProgressBar.src = strGifFolder + ProgressFileName[iPosition];
	if (!ModemHelper_StopProgressBar())
		setTimeout("ModemHelper_DisplayGifProgressBar('" + strIdProgressBar + "', '" +
													  strGifFolder + "')", 100);
}

//______________________________________________________________________________________________________________________
function ModemHelper_StartGifProgressBar(strIdProgressBar, iRestart)
{
	var objProgressBar = document.getElementById(strIdProgressBar);
	var strGifFileName = objProgressBar.src;

	iPosition = strGifFileName.lastIndexOf("/") + 1;
	if (iPosition > 0)
	{
		strGifFolder = strGifFileName.substr(0, iPosition);
		if (iRestart == 1)
		{
			try
			{
				ModemHelper.StartProgressBar();
			}
			catch(e)
			{
				external.StartProgressBar();
			}
		}
		ModemHelper_DisplayGifProgressBar(strIdProgressBar, strGifFolder);
	}
}

//______________________________________________________________________________________________________________________
function CallFunctions()
{
	cArguments = CallFunctions.arguments;
	iNbArguments = cArguments.length - 1;
	iDiagnosticCode = cArguments[iNbArguments];
	bUseResult = false;
	while (iNbArguments > 0)
	{
		bSendResult = false;
		iNbArguments--;
		execScript(cArguments[iNbArguments]);
		if (!bSendResult)
			break;
	}
	bUseResult = true;
	if (bSendResult)
		ModemHelper_Result(iDiagnosticCode);
	return true;
}
